Index: branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Clients.Hive/3.4/ServiceClients/HiveServiceClient.cs
===================================================================
--- branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Clients.Hive/3.4/ServiceClients/HiveServiceClient.cs	(revision 5597)
+++ branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Clients.Hive/3.4/ServiceClients/HiveServiceClient.cs	(revision 5599)
@@ -976,52 +1150,17 @@
         
         [System.Runtime.Serialization.EnumMemberAttribute()]
-        Finished = 2,
+        Transferring = 2,
         
         [System.Runtime.Serialization.EnumMemberAttribute()]
-        Aborted = 3,
+        Calculating = 3,
         
         [System.Runtime.Serialization.EnumMemberAttribute()]
-        Failed = 4,
+        Finished = 4,
         
         [System.Runtime.Serialization.EnumMemberAttribute()]
-        WaitForChildJobs = 5,
-    }
-    
-    [System.CodeDom.Compiler.GeneratedCodeAttribute("System.Runtime.Serialization", "4.0.0.0")]
-    [System.Runtime.Serialization.DataContractAttribute(Name="CalendarState", Namespace="http://schemas.datacontract.org/2004/07/HeuristicLab.Services.Hive.Common.DataTra" +
-        "nsfer")]
-    public enum CalendarState : int
-    {
+        Aborted = 5,
         
         [System.Runtime.Serialization.EnumMemberAttribute()]
-        Fetch = 0,
-        
-        [System.Runtime.Serialization.EnumMemberAttribute()]
-        ForceFetch = 1,
-        
-        [System.Runtime.Serialization.EnumMemberAttribute()]
-        Fetching = 2,
-        
-        [System.Runtime.Serialization.EnumMemberAttribute()]
-        Fetched = 3,
-        
-        [System.Runtime.Serialization.EnumMemberAttribute()]
-        NotAllowedToFetch = 4,
-    }
-    
-    [System.CodeDom.Compiler.GeneratedCodeAttribute("System.Runtime.Serialization", "4.0.0.0")]
-    [System.Runtime.Serialization.DataContractAttribute(Name="SlaveState", Namespace="http://schemas.datacontract.org/2004/07/HeuristicLab.Services.Hive.Common.DataTra" +
-        "nsfer")]
-    public enum SlaveState : int
-    {
-        
-        [System.Runtime.Serialization.EnumMemberAttribute()]
-        Idle = 0,
-        
-        [System.Runtime.Serialization.EnumMemberAttribute()]
-        Calculating = 1,
-        
-        [System.Runtime.Serialization.EnumMemberAttribute()]
-        Offline = 2,
+        Failed = 6,
     }
     
@@ -1030,17 +1169,24 @@
     [System.Runtime.Serialization.DataContractAttribute(Name="Heartbeat", Namespace="http://schemas.datacontract.org/2004/07/HeuristicLab.Services.Hive.Common.DataTra" +
         "nsfer")]
+    [System.SerializableAttribute()]
     public partial class Heartbeat : object, System.Runtime.Serialization.IExtensibleDataObject, System.ComponentModel.INotifyPropertyChanged
     {
         
+        [System.NonSerializedAttribute()]
         private System.Runtime.Serialization.ExtensionDataObject extensionDataField;
         
+        [System.Runtime.Serialization.OptionalFieldAttribute()]
+        private bool AssignJobField;
+        
+        [System.Runtime.Serialization.OptionalFieldAttribute()]
         private int FreeCoresField;
         
+        [System.Runtime.Serialization.OptionalFieldAttribute()]
         private int FreeMemoryField;
         
-        private bool IsAllowedToCalculateField;
-        
+        [System.Runtime.Serialization.OptionalFieldAttribute()]
         private System.Collections.Generic.Dictionary<System.Guid, System.TimeSpan> JobProgressField;
         
+        [System.Runtime.Serialization.OptionalFieldAttribute()]
         private System.Guid SlaveIdField;
         
@@ -1054,4 +1200,21 @@
             {
                 this.extensionDataField = value;
+            }
+        }
+        
+        [System.Runtime.Serialization.DataMemberAttribute()]
+        public bool AssignJob
+        {
+            get
+            {
+                return this.AssignJobField;
+            }
+            set
+            {
+                if ((this.AssignJobField.Equals(value) != true))
+                {
+                    this.AssignJobField = value;
+                    this.RaisePropertyChanged("AssignJob");
+                }
             }
         }
@@ -1087,21 +1250,4 @@
                     this.FreeMemoryField = value;
                     this.RaisePropertyChanged("FreeMemory");
-                }
-            }
-        }
-        
-        [System.Runtime.Serialization.DataMemberAttribute()]
-        public bool IsAllowedToCalculate
-        {
-            get
-            {
-                return this.IsAllowedToCalculateField;
-            }
-            set
-            {
-                if ((this.IsAllowedToCalculateField.Equals(value) != true))
-                {
-                    this.IsAllowedToCalculateField = value;
-                    this.RaisePropertyChanged("IsAllowedToCalculate");
                 }
             }
@@ -1157,12 +1303,16 @@
     [System.CodeDom.Compiler.GeneratedCodeAttribute("System.Runtime.Serialization", "4.0.0.0")]
     [System.Runtime.Serialization.DataContractAttribute(Name="MessageContainer", Namespace="http://schemas.datacontract.org/2004/07/HeuristicLab.Services.Hive.Common")]
+    [System.SerializableAttribute()]
     public partial class MessageContainer : object, System.Runtime.Serialization.IExtensibleDataObject, System.ComponentModel.INotifyPropertyChanged
     {
         
+        [System.NonSerializedAttribute()]
         private System.Runtime.Serialization.ExtensionDataObject extensionDataField;
         
-        private System.Guid JobIdk__BackingFieldField;
-        
-        private HeuristicLab.Clients.Hive.MessageContainer.MessageType Messagek__BackingFieldField;
+        [System.Runtime.Serialization.OptionalFieldAttribute()]
+        private System.Guid JobIdField;
+        
+        [System.Runtime.Serialization.OptionalFieldAttribute()]
+        private HeuristicLab.Clients.Hive.MessageContainer.MessageType MessageField;
         
         public System.Runtime.Serialization.ExtensionDataObject ExtensionData
@@ -1178,34 +1328,34 @@
         }
         
-        [System.Runtime.Serialization.DataMemberAttribute(Name="<JobId>k__BackingField", IsRequired=true)]
-        public System.Guid JobIdk__BackingField
-        {
-            get
-            {
-                return this.JobIdk__BackingFieldField;
-            }
-            set
-            {
-                if ((this.JobIdk__BackingFieldField.Equals(value) != true))
-                {
-                    this.JobIdk__BackingFieldField = value;
-                    this.RaisePropertyChanged("JobIdk__BackingField");
-                }
-            }
-        }
-        
-        [System.Runtime.Serialization.DataMemberAttribute(Name="<Message>k__BackingField", IsRequired=true)]
-        public HeuristicLab.Clients.Hive.MessageContainer.MessageType Messagek__BackingField
-        {
-            get
-            {
-                return this.Messagek__BackingFieldField;
-            }
-            set
-            {
-                if ((this.Messagek__BackingFieldField.Equals(value) != true))
-                {
-                    this.Messagek__BackingFieldField = value;
-                    this.RaisePropertyChanged("Messagek__BackingField");
+        [System.Runtime.Serialization.DataMemberAttribute()]
+        public System.Guid JobId
+        {
+            get
+            {
+                return this.JobIdField;
+            }
+            set
+            {
+                if ((this.JobIdField.Equals(value) != true))
+                {
+                    this.JobIdField = value;
+                    this.RaisePropertyChanged("JobId");
+                }
+            }
+        }
+        
+        [System.Runtime.Serialization.DataMemberAttribute()]
+        public HeuristicLab.Clients.Hive.MessageContainer.MessageType Message
+        {
+            get
+            {
+                return this.MessageField;
+            }
+            set
+            {
+                if ((this.MessageField.Equals(value) != true))
+                {
+                    this.MessageField = value;
+                    this.RaisePropertyChanged("Message");
                 }
             }
@@ -1229,38 +1379,38 @@
             
             [System.Runtime.Serialization.EnumMemberAttribute()]
-            FetchJob = 0,
+            CalculateJob = 0,
             
             [System.Runtime.Serialization.EnumMemberAttribute()]
-            AbortJob = 1,
+            StopJob = 1,
             
             [System.Runtime.Serialization.EnumMemberAttribute()]
-            JobAborted = 2,
+            StopAll = 2,
             
             [System.Runtime.Serialization.EnumMemberAttribute()]
-            FinishedJob = 3,
+            AbortJob = 3,
             
             [System.Runtime.Serialization.EnumMemberAttribute()]
-            NoMessage = 4,
+            AbortAll = 4,
             
             [System.Runtime.Serialization.EnumMemberAttribute()]
-            SnapshotReady = 5,
+            PauseJob = 5,
             
             [System.Runtime.Serialization.EnumMemberAttribute()]
-            Shutdown = 6,
+            PauseAll = 6,
             
             [System.Runtime.Serialization.EnumMemberAttribute()]
-            JobFailed = 7,
+            Restart = 7,
             
             [System.Runtime.Serialization.EnumMemberAttribute()]
-            UptimeLimitDisconnect = 8,
+            Sleep = 8,
             
             [System.Runtime.Serialization.EnumMemberAttribute()]
-            UpdateCalendar = 9,
+            ShutdownSlave = 9,
             
             [System.Runtime.Serialization.EnumMemberAttribute()]
-            AddChildJob = 10,
+            SayHello = 10,
             
             [System.Runtime.Serialization.EnumMemberAttribute()]
-            PauseJob = 11,
+            AddChildJob = 11,
             
             [System.Runtime.Serialization.EnumMemberAttribute()]
@@ -1269,7 +1419,4 @@
             [System.Runtime.Serialization.EnumMemberAttribute()]
             DeleteChildJobs = 13,
-            
-            [System.Runtime.Serialization.EnumMemberAttribute()]
-            AddSlaveInfo = 14,
         }
     }
@@ -1280,9 +1427,39 @@
     {
         
+        [System.ServiceModel.OperationContractAttribute(Action="http://tempuri.org/IHiveService/GetSlaves", ReplyAction="http://tempuri.org/IHiveService/GetSlavesResponse")]
+        System.Collections.Generic.List<HeuristicLab.Clients.Hive.Slave> GetSlaves();
+        
+        [System.ServiceModel.OperationContractAttribute(Action="http://tempuri.org/IHiveService/GetSlaveGroups", ReplyAction="http://tempuri.org/IHiveService/GetSlaveGroupsResponse")]
+        System.Collections.Generic.List<HeuristicLab.Clients.Hive.SlaveGroup> GetSlaveGroups();
+        
+        [System.ServiceModel.OperationContractAttribute(Action="http://tempuri.org/IHiveService/UpdateSlave", ReplyAction="http://tempuri.org/IHiveService/UpdateSlaveResponse")]
+        void UpdateSlave(HeuristicLab.Clients.Hive.Slave slave);
+        
+        [System.ServiceModel.OperationContractAttribute(Action="http://tempuri.org/IHiveService/UpdateSlaveGroup", ReplyAction="http://tempuri.org/IHiveService/UpdateSlaveGroupResponse")]
+        void UpdateSlaveGroup(HeuristicLab.Clients.Hive.SlaveGroup slaveGroup);
+        
+        [System.ServiceModel.OperationContractAttribute(Action="http://tempuri.org/IHiveService/DeleteSlave", ReplyAction="http://tempuri.org/IHiveService/DeleteSlaveResponse")]
+        void DeleteSlave(System.Guid slaveId);
+        
+        [System.ServiceModel.OperationContractAttribute(Action="http://tempuri.org/IHiveService/DeleteSlaveGroup", ReplyAction="http://tempuri.org/IHiveService/DeleteSlaveGroupResponse")]
+        void DeleteSlaveGroup(System.Guid slaveGroupId);
+        
+        [System.ServiceModel.OperationContractAttribute(Action="http://tempuri.org/IHiveService/AddResourceToGroup", ReplyAction="http://tempuri.org/IHiveService/AddResourceToGroupResponse")]
+        void AddResourceToGroup(System.Guid slaveGroupId, System.Guid resourceId);
+        
+        [System.ServiceModel.OperationContractAttribute(Action="http://tempuri.org/IHiveService/RemoveResourceFromGroup", ReplyAction="http://tempuri.org/IHiveService/RemoveResourceFromGroupResponse")]
+        void RemoveResourceFromGroup(System.Guid slaveGroupId, System.Guid resourceId);
+        
+        [System.ServiceModel.OperationContractAttribute(Action="http://tempuri.org/IHiveService/GetResourceId", ReplyAction="http://tempuri.org/IHiveService/GetResourceIdResponse")]
+        System.Guid GetResourceId(string resourceName);
+        
+        [System.ServiceModel.OperationContractAttribute(Action="http://tempuri.org/IHiveService/TriggerLifecycle", ReplyAction="http://tempuri.org/IHiveService/TriggerLifecycleResponse")]
+        void TriggerLifecycle();
+        
         [System.ServiceModel.OperationContractAttribute(Action="http://tempuri.org/IHiveService/AddJob", ReplyAction="http://tempuri.org/IHiveService/AddJobResponse")]
-        System.Guid AddJob(HeuristicLab.Clients.Hive.Job jobDto, HeuristicLab.Clients.Hive.JobData jobDataDto);
+        System.Guid AddJob(HeuristicLab.Clients.Hive.Job job, HeuristicLab.Clients.Hive.JobData jobData, System.Collections.Generic.List<System.Guid> resourceIds);
         
         [System.ServiceModel.OperationContractAttribute(Action="http://tempuri.org/IHiveService/AddChildJob", ReplyAction="http://tempuri.org/IHiveService/AddChildJobResponse")]
-        System.Guid AddChildJob(System.Guid parentJobId, HeuristicLab.Clients.Hive.Job jobDto, HeuristicLab.Clients.Hive.JobData jobDataDto);
+        System.Guid AddChildJob(System.Guid parentJobId, HeuristicLab.Clients.Hive.Job job, HeuristicLab.Clients.Hive.JobData jobData);
         
         [System.ServiceModel.OperationContractAttribute(Action="http://tempuri.org/IHiveService/GetJob", ReplyAction="http://tempuri.org/IHiveService/GetJobResponse")]
@@ -1290,35 +1467,32 @@
         
         [System.ServiceModel.OperationContractAttribute(Action="http://tempuri.org/IHiveService/GetJobs", ReplyAction="http://tempuri.org/IHiveService/GetJobsResponse")]
-        HeuristicLab.Clients.Hive.Job[] GetJobs();
+        System.Collections.Generic.List<HeuristicLab.Clients.Hive.Job> GetJobs();
         
         [System.ServiceModel.OperationContractAttribute(Action="http://tempuri.org/IHiveService/GetLightweightJobs", ReplyAction="http://tempuri.org/IHiveService/GetLightweightJobsResponse")]
-        HeuristicLab.Clients.Hive.LightweightJob[] GetLightweightJobs(System.Guid[] jobIds);
+        System.Collections.Generic.List<HeuristicLab.Clients.Hive.LightweightJob> GetLightweightJobs(System.Collections.Generic.List<System.Guid> jobIds);
         
         [System.ServiceModel.OperationContractAttribute(Action="http://tempuri.org/IHiveService/GetLightweightChildJobs", ReplyAction="http://tempuri.org/IHiveService/GetLightweightChildJobsResponse")]
-        HeuristicLab.Clients.Hive.LightweightJob[] GetLightweightChildJobs(System.Nullable<System.Guid> parentJobId, bool recursive, bool includeParent);
+        System.Collections.Generic.List<HeuristicLab.Clients.Hive.LightweightJob> GetLightweightChildJobs(System.Nullable<System.Guid> parentJobId, bool recursive, bool includeParent);
         
         [System.ServiceModel.OperationContractAttribute(Action="http://tempuri.org/IHiveService/GetJobData", ReplyAction="http://tempuri.org/IHiveService/GetJobDataResponse")]
         HeuristicLab.Clients.Hive.JobData GetJobData(System.Guid jobId);
         
-        [System.ServiceModel.OperationContractAttribute(Action="http://tempuri.org/IHiveService/GetJobDataStreamed", ReplyAction="http://tempuri.org/IHiveService/GetJobDataStreamedResponse")]
-        System.IO.Stream GetJobDataStreamed(System.Guid jobId);
-        
         [System.ServiceModel.OperationContractAttribute(Action="http://tempuri.org/IHiveService/UpdateJob", ReplyAction="http://tempuri.org/IHiveService/UpdateJobResponse")]
-        void UpdateJob(HeuristicLab.Clients.Hive.Job jobDto, HeuristicLab.Clients.Hive.JobData jobDataDto);
-        
-        [System.ServiceModel.OperationContractAttribute(Action="http://tempuri.org/IHiveService/UpdateJobDataStreamed", ReplyAction="http://tempuri.org/IHiveService/UpdateJobDataStreamedResponse")]
-        void UpdateJobDataStreamed(System.IO.Stream stream);
+        void UpdateJob(HeuristicLab.Clients.Hive.Job jobDto);
+        
+        [System.ServiceModel.OperationContractAttribute(Action="http://tempuri.org/IHiveService/UpdateJobData", ReplyAction="http://tempuri.org/IHiveService/UpdateJobDataResponse")]
+        void UpdateJobData(HeuristicLab.Clients.Hive.Job jobDto, HeuristicLab.Clients.Hive.JobData jobDataDto);
+        
+        [System.ServiceModel.OperationContractAttribute(Action="http://tempuri.org/IHiveService/DeleteJob", ReplyAction="http://tempuri.org/IHiveService/DeleteJobResponse")]
+        void DeleteJob(System.Guid jobId);
         
         [System.ServiceModel.OperationContractAttribute(Action="http://tempuri.org/IHiveService/DeleteChildJobs", ReplyAction="http://tempuri.org/IHiveService/DeleteChildJobsResponse")]
         void DeleteChildJobs(System.Guid parentJobId);
         
-        [System.ServiceModel.OperationContractAttribute(Action="http://tempuri.org/IHiveService/AquireJob", ReplyAction="http://tempuri.org/IHiveService/AquireJobResponse")]
-        HeuristicLab.Clients.Hive.Job AquireJob(System.Guid slaveId);
-        
-        [System.ServiceModel.OperationContractAttribute(Action="http://tempuri.org/IHiveService/AbortJob", ReplyAction="http://tempuri.org/IHiveService/AbortJobResponse")]
-        void AbortJob(System.Guid jobId);
+        [System.ServiceModel.OperationContractAttribute(Action="http://tempuri.org/IHiveService/StopJob", ReplyAction="http://tempuri.org/IHiveService/StopJobResponse")]
+        void StopJob(System.Guid jobId);
         
         [System.ServiceModel.OperationContractAttribute(Action="http://tempuri.org/IHiveService/PauseJob", ReplyAction="http://tempuri.org/IHiveService/PauseJobResponse")]
-        HeuristicLab.Clients.Hive.Job PauseJob(HeuristicLab.Clients.Hive.JobData serializedJob);
+        void PauseJob(System.Guid jobId);
         
         [System.ServiceModel.OperationContractAttribute(Action="http://tempuri.org/IHiveService/GetHiveExperiment", ReplyAction="http://tempuri.org/IHiveService/GetHiveExperimentResponse")]
@@ -1326,5 +1500,5 @@
         
         [System.ServiceModel.OperationContractAttribute(Action="http://tempuri.org/IHiveService/GetHiveExperiments", ReplyAction="http://tempuri.org/IHiveService/GetHiveExperimentsResponse")]
-        HeuristicLab.Clients.Hive.HiveExperiment[] GetHiveExperiments();
+        System.Collections.Generic.List<HeuristicLab.Clients.Hive.HiveExperiment> GetHiveExperiments();
         
         [System.ServiceModel.OperationContractAttribute(Action="http://tempuri.org/IHiveService/AddHiveExperiment", ReplyAction="http://tempuri.org/IHiveService/AddHiveExperimentResponse")]
@@ -1337,60 +1511,33 @@
         void DeleteHiveExperiment(System.Guid hiveExperimentId);
         
-        [System.ServiceModel.OperationContractAttribute(Action="http://tempuri.org/IHiveService/GetAllProjects", ReplyAction="http://tempuri.org/IHiveService/GetAllProjectsResponse")]
-        HeuristicLab.Clients.Hive.Project GetAllProjects();
-        
-        [System.ServiceModel.OperationContractAttribute(Action="http://tempuri.org/IHiveService/CreateProject", ReplyAction="http://tempuri.org/IHiveService/CreateProjectResponse")]
-        void CreateProject(HeuristicLab.Clients.Hive.Project project);
-        
-        [System.ServiceModel.OperationContractAttribute(Action="http://tempuri.org/IHiveService/ChangeProject", ReplyAction="http://tempuri.org/IHiveService/ChangeProjectResponse")]
-        void ChangeProject(HeuristicLab.Clients.Hive.Project project);
-        
-        [System.ServiceModel.OperationContractAttribute(Action="http://tempuri.org/IHiveService/DeleteProject", ReplyAction="http://tempuri.org/IHiveService/DeleteProjectResponse")]
-        void DeleteProject(System.Guid projectId);
-        
-        [System.ServiceModel.OperationContractAttribute(Action="http://tempuri.org/IHiveService/GetJobsByProject", ReplyAction="http://tempuri.org/IHiveService/GetJobsByProjectResponse")]
-        HeuristicLab.Clients.Hive.Job[] GetJobsByProject(System.Guid projectId);
-        
-        [System.ServiceModel.OperationContractAttribute(Action="http://tempuri.org/IHiveService/ProcessHeartbeat", ReplyAction="http://tempuri.org/IHiveService/ProcessHeartbeatResponse")]
-        HeuristicLab.Clients.Hive.MessageContainer[] ProcessHeartbeat(HeuristicLab.Clients.Hive.Heartbeat heartbeat);
+        [System.ServiceModel.OperationContractAttribute(Action="http://tempuri.org/IHiveService/Hello", ReplyAction="http://tempuri.org/IHiveService/HelloResponse")]
+        void Hello(HeuristicLab.Clients.Hive.Slave slave);
+        
+        [System.ServiceModel.OperationContractAttribute(Action="http://tempuri.org/IHiveService/GoodBye", ReplyAction="http://tempuri.org/IHiveService/GoodByeResponse")]
+        void GoodBye(System.Guid slaveId);
+        
+        [System.ServiceModel.OperationContractAttribute(Action="http://tempuri.org/IHiveService/Heartbeat", ReplyAction="http://tempuri.org/IHiveService/HeartbeatResponse")]
+        System.Collections.Generic.List<HeuristicLab.Clients.Hive.MessageContainer> Heartbeat([System.ServiceModel.MessageParameterAttribute(Name="heartbeat")] HeuristicLab.Clients.Hive.Heartbeat heartbeat1);
+        
+        [System.ServiceModel.OperationContractAttribute(Action="http://tempuri.org/IHiveService/AddPlugin", ReplyAction="http://tempuri.org/IHiveService/AddPluginResponse")]
+        System.Guid AddPlugin(HeuristicLab.Clients.Hive.Plugin plugin, System.Collections.Generic.List<HeuristicLab.Clients.Hive.PluginData> pluginData);
         
         [System.ServiceModel.OperationContractAttribute(Action="http://tempuri.org/IHiveService/GetPlugins", ReplyAction="http://tempuri.org/IHiveService/GetPluginsResponse")]
-        HeuristicLab.Clients.Hive.HivePluginData[] GetPlugins(HeuristicLab.Clients.Hive.HivePlugin[] pluginList);
-        
-        [System.ServiceModel.OperationContractAttribute(Action="http://tempuri.org/IHiveService/GetStreamedPlugins", ReplyAction="http://tempuri.org/IHiveService/GetStreamedPluginsResponse")]
-        System.IO.Stream GetStreamedPlugins(HeuristicLab.Clients.Hive.HivePlugin[] pluginList);
-        
-        [System.ServiceModel.OperationContractAttribute(Action="http://tempuri.org/IHiveService/GetCalendar", ReplyAction="http://tempuri.org/IHiveService/GetCalendarResponse")]
-        HeuristicLab.Clients.Hive.Appointment[] GetCalendar(System.Guid slaveId);
-        
-        [System.ServiceModel.OperationContractAttribute(Action="http://tempuri.org/IHiveService/SetCalendarStatus", ReplyAction="http://tempuri.org/IHiveService/SetCalendarStatusResponse")]
-        void SetCalendarStatus(System.Guid clientId, HeuristicLab.Clients.Hive.CalendarState state);
-        
-        [System.ServiceModel.OperationContractAttribute(Action="http://tempuri.org/IHiveService/GetUptimeCalendarForResource", ReplyAction="http://tempuri.org/IHiveService/GetUptimeCalendarForResourceResponse")]
-        HeuristicLab.Clients.Hive.Appointment[] GetUptimeCalendarForResource(System.Guid guid);
-        
-        [System.ServiceModel.OperationContractAttribute(Action="http://tempuri.org/IHiveService/SetUptimeCalendarForResource", ReplyAction="http://tempuri.org/IHiveService/SetUptimeCalendarForResourceResponse")]
-        void SetUptimeCalendarForResource(System.Guid guid, HeuristicLab.Clients.Hive.Appointment[] appointments, bool isForced);
+        System.Collections.Generic.List<HeuristicLab.Clients.Hive.Plugin> GetPlugins();
+        
+        [System.ServiceModel.OperationContractAttribute(Action="http://tempuri.org/IHiveService/GetPluginDatas", ReplyAction="http://tempuri.org/IHiveService/GetPluginDatasResponse")]
+        System.Collections.Generic.List<HeuristicLab.Clients.Hive.PluginData> GetPluginDatas(System.Collections.Generic.List<System.Guid> pluginIds);
+        
+        [System.ServiceModel.OperationContractAttribute(Action="http://tempuri.org/IHiveService/AddSlave", ReplyAction="http://tempuri.org/IHiveService/AddSlaveResponse")]
+        System.Guid AddSlave(HeuristicLab.Clients.Hive.Slave slave);
         
         [System.ServiceModel.OperationContractAttribute(Action="http://tempuri.org/IHiveService/AddSlaveGroup", ReplyAction="http://tempuri.org/IHiveService/AddSlaveGroupResponse")]
         System.Guid AddSlaveGroup(HeuristicLab.Clients.Hive.SlaveGroup slaveGroup);
         
-        [System.ServiceModel.OperationContractAttribute(Action="http://tempuri.org/IHiveService/GetSlaves", ReplyAction="http://tempuri.org/IHiveService/GetSlavesResponse")]
-        HeuristicLab.Clients.Hive.Slave[] GetSlaves();
-        
-        [System.ServiceModel.OperationContractAttribute(Action="http://tempuri.org/IHiveService/GetSlaveGroups", ReplyAction="http://tempuri.org/IHiveService/GetSlaveGroupsResponse")]
-        HeuristicLab.Clients.Hive.SlaveGroup[] GetSlaveGroups();
-        
-        [System.ServiceModel.OperationContractAttribute(Action="http://tempuri.org/IHiveService/DeleteSlaveGroup", ReplyAction="http://tempuri.org/IHiveService/DeleteSlaveGroupResponse")]
-        void DeleteSlaveGroup(System.Guid clientGroupId);
-        
-        [System.ServiceModel.OperationContractAttribute(Action="http://tempuri.org/IHiveService/AddResourceToGroup", ReplyAction="http://tempuri.org/IHiveService/AddResourceToGroupResponse")]
-        void AddResourceToGroup(System.Guid slaveGroupId, HeuristicLab.Clients.Hive.Resource resource);
-        
-        [System.ServiceModel.OperationContractAttribute(Action="http://tempuri.org/IHiveService/RemoveResourceFromGroup", ReplyAction="http://tempuri.org/IHiveService/RemoveResourceFromGroupResponse")]
-        void RemoveResourceFromGroup(System.Guid slaveGroupId, System.Guid resourceId);
-        
-        [System.ServiceModel.OperationContractAttribute(Action="http://tempuri.org/IHiveService/UpdateSlave", ReplyAction="http://tempuri.org/IHiveService/UpdateSlaveResponse")]
-        void UpdateSlave(HeuristicLab.Clients.Hive.Slave slave);
+        [System.ServiceModel.OperationContractAttribute(Action="http://tempuri.org/IHiveService/GetSlave", ReplyAction="http://tempuri.org/IHiveService/GetSlaveResponse")]
+        HeuristicLab.Clients.Hive.Slave GetSlave(System.Guid slaveId);
+        
+        [System.ServiceModel.OperationContractAttribute(Action="http://tempuri.org/IHiveService/GetSlaveGroup", ReplyAction="http://tempuri.org/IHiveService/GetSlaveGroupResponse")]
+        HeuristicLab.Clients.Hive.SlaveGroup GetSlaveGroup(System.Guid slaveGroupId);
     }
     
@@ -1429,12 +1576,62 @@
         }
         
-        public System.Guid AddJob(HeuristicLab.Clients.Hive.Job jobDto, HeuristicLab.Clients.Hive.JobData jobDataDto)
-        {
-            return base.Channel.AddJob(jobDto, jobDataDto);
-        }
-        
-        public System.Guid AddChildJob(System.Guid parentJobId, HeuristicLab.Clients.Hive.Job jobDto, HeuristicLab.Clients.Hive.JobData jobDataDto)
-        {
-            return base.Channel.AddChildJob(parentJobId, jobDto, jobDataDto);
+        public System.Collections.Generic.List<HeuristicLab.Clients.Hive.Slave> GetSlaves()
+        {
+            return base.Channel.GetSlaves();
+        }
+        
+        public System.Collections.Generic.List<HeuristicLab.Clients.Hive.SlaveGroup> GetSlaveGroups()
+        {
+            return base.Channel.GetSlaveGroups();
+        }
+        
+        public void UpdateSlave(HeuristicLab.Clients.Hive.Slave slave)
+        {
+            base.Channel.UpdateSlave(slave);
+        }
+        
+        public void UpdateSlaveGroup(HeuristicLab.Clients.Hive.SlaveGroup slaveGroup)
+        {
+            base.Channel.UpdateSlaveGroup(slaveGroup);
+        }
+        
+        public void DeleteSlave(System.Guid slaveId)
+        {
+            base.Channel.DeleteSlave(slaveId);
+        }
+        
+        public void DeleteSlaveGroup(System.Guid slaveGroupId)
+        {
+            base.Channel.DeleteSlaveGroup(slaveGroupId);
+        }
+        
+        public void AddResourceToGroup(System.Guid slaveGroupId, System.Guid resourceId)
+        {
+            base.Channel.AddResourceToGroup(slaveGroupId, resourceId);
+        }
+        
+        public void RemoveResourceFromGroup(System.Guid slaveGroupId, System.Guid resourceId)
+        {
+            base.Channel.RemoveResourceFromGroup(slaveGroupId, resourceId);
+        }
+        
+        public System.Guid GetResourceId(string resourceName)
+        {
+            return base.Channel.GetResourceId(resourceName);
+        }
+        
+        public void TriggerLifecycle()
+        {
+            base.Channel.TriggerLifecycle();
+        }
+        
+        public System.Guid AddJob(HeuristicLab.Clients.Hive.Job job, HeuristicLab.Clients.Hive.JobData jobData, System.Collections.Generic.List<System.Guid> resourceIds)
+        {
+            return base.Channel.AddJob(job, jobData, resourceIds);
+        }
+        
+        public System.Guid AddChildJob(System.Guid parentJobId, HeuristicLab.Clients.Hive.Job job, HeuristicLab.Clients.Hive.JobData jobData)
+        {
+            return base.Channel.AddChildJob(parentJobId, job, jobData);
         }
         
@@ -1444,15 +1641,15 @@
         }
         
-        public HeuristicLab.Clients.Hive.Job[] GetJobs()
+        public System.Collections.Generic.List<HeuristicLab.Clients.Hive.Job> GetJobs()
         {
             return base.Channel.GetJobs();
         }
         
-        public HeuristicLab.Clients.Hive.LightweightJob[] GetLightweightJobs(System.Guid[] jobIds)
+        public System.Collections.Generic.List<HeuristicLab.Clients.Hive.LightweightJob> GetLightweightJobs(System.Collections.Generic.List<System.Guid> jobIds)
         {
             return base.Channel.GetLightweightJobs(jobIds);
         }
         
-        public HeuristicLab.Clients.Hive.LightweightJob[] GetLightweightChildJobs(System.Nullable<System.Guid> parentJobId, bool recursive, bool includeParent)
+        public System.Collections.Generic.List<HeuristicLab.Clients.Hive.LightweightJob> GetLightweightChildJobs(System.Nullable<System.Guid> parentJobId, bool recursive, bool includeParent)
         {
             return base.Channel.GetLightweightChildJobs(parentJobId, recursive, includeParent);
@@ -1464,17 +1661,17 @@
         }
         
-        public System.IO.Stream GetJobDataStreamed(System.Guid jobId)
-        {
-            return base.Channel.GetJobDataStreamed(jobId);
-        }
-        
-        public void UpdateJob(HeuristicLab.Clients.Hive.Job jobDto, HeuristicLab.Clients.Hive.JobData jobDataDto)
-        {
-            base.Channel.UpdateJob(jobDto, jobDataDto);
-        }
-        
-        public void UpdateJobDataStreamed(System.IO.Stream stream)
-        {
-            base.Channel.UpdateJobDataStreamed(stream);
+        public void UpdateJob(HeuristicLab.Clients.Hive.Job jobDto)
+        {
+            base.Channel.UpdateJob(jobDto);
+        }
+        
+        public void UpdateJobData(HeuristicLab.Clients.Hive.Job jobDto, HeuristicLab.Clients.Hive.JobData jobDataDto)
+        {
+            base.Channel.UpdateJobData(jobDto, jobDataDto);
+        }
+        
+        public void DeleteJob(System.Guid jobId)
+        {
+            base.Channel.DeleteJob(jobId);
         }
         
